<?php

namespace Bydedi\Tracking\Google;

/**
 * Class TagManager
 * @package Bydedi\Tracking\Google
 */
class TagManager
{
    /**
     * @var bool
     */
    protected static $isInit = false;

    /**
     * @var array|null $config
     */
    protected static $config = null;

    /**
     * @param array $config
     */
    public static function init($config = array())
    {
        self::$config = $config;
    }

    /**
     * Check if it's initialized.
     * If not trigger a warning error
     */
    protected static function triggerErrorIfNotInit()
    {
        if (is_null(self::$config)) {
            trigger_error("Google Tag Manager n'est pas initialisé", E_USER_WARNING);
        }
    }

    protected static function assign($data_layer, $param)
    {
        $infos = self::common($param);

        $tracker = "";

        if (!empty($infos)) {
            $data_layer = array_merge($infos[0], $data_layer);
            $tracker.= $infos[1];
        }

        $data_layer = '<script>dataLayer = [' . json_encode($data_layer) . '];</script>';
        if (isset($param['smarty'])) {
            $param['smarty']->reassign(self::$config['position'], $data_layer . $tracker);
        }
    }

    public static function common($param)
    {
        if (self::$isInit == true) {
            return false;
        }

        self::$isInit = true;

        $data_layer = array(
            "env_template" => "",
        );

        $tracker = "
            <!-- Google Tag Manager -->
            <noscript><iframe src=\"//www.googletagmanager.com/ns.html?id=%s\"
            height=\"0\" width=\"0\" style=\"display:none;visibility:hidden\"></iframe></noscript>
            <script>(function(w,d,s,l,i){w[l]=w[l]||[];w[l].push({'gtm.start':
            new Date().getTime(),event:'gtm.js'});var f=d.getElementsByTagName(s)[0],
            j=d.createElement(s),dl=l!='dataLayer'?'&l='+l:'';j.async=true;j.src=
            '//www.googletagmanager.com/gtm.js?id='+i+dl;f.parentNode.insertBefore(j,f);
            })(window,document,'script','dataLayer','%s');</script>
            <!-- End Google Tag Manager -->
        ";

        $tracker = sprintf($tracker, self::$config['id'], self::$config['id']);

        return array($data_layer, $tracker);
    }

    public static function home($param = array())
    {
        $data_layer = array(

        );

        self::assign($data_layer, $param);
    }

    public static function category($param = array())
    {
        $data_layer = array(
            'breadcrumb_id' => '',
            'breadcrumb_label' => '',
            'page_id' => '',
        );

        self::assign($data_layer, $param);
    }

    public static function product($param = array())
    {
        $data_layer = array(
            'breadcrumb_id' => '',
            'breadcrumb_label' => '',
            'product_sku' => '',
            'product_name' => '',
            'product_unitprice_ati' => '',
            'product_designer' => '',
        );

        self::assign($data_layer, $param);
    }

    public static function cart($param = array())
    {
        $data_layer = array(
            'basket_id' => '',
            'basket_amount_ati' => '',
            'basket_product_number' => '',
        );

        self::assign($data_layer, $param);
    }

    public static function paiement($param = array())
    {

        $data_layer = array(
            'order_id' => $param['extra']['commande_id'],
            'order_amount_ati_with_sf' => $param['extra']['commande_total_ttc'],
            'order_payment_methods' => $param['extra']['paiement_nom_nom'],
            'order_products_number' => '',
            'order_products' => '',
        );

        self::assign($data_layer, $param);

        /*self::common($param);

        $out = "<script>\n";
        $out.= "ga('require', 'ecommerce')\n";

        // transaction
        $out.= "ga('ecommerce:addTransaction', {\n";
        $out.= "'id': '".$param['extra']['commande_id']."',\n"; // Transaction ID. obligatoire
        $out.= "'affiliation': '".$param['extra']['commande_referer']."',\n"; // Affilié non obligatoire
        $out.= "'revenue': '".$param['extra']['commande_total_ttc']."',\n"; // Total.
        $out.= "'shipping': '".$param['extra']['commande_port_ttc']."',\n"; // frais envoi.
        $out.= "'tax': '".round($param['extra']['commande_total_taxe'], 2)."'\n"; // Tax.
        $out.= "});\n";

        foreach ($param['extra']['produits'] as $produit) {
            $categorieName = '';
            if (!empty($produit['categories'])) {
                if (!empty($produit['categories'][0]['grand_parent_nom'])) {
                    $categorieName .= $produit['categories'][0]['grand_parent_nom'] . ',';
                }

                if (!empty($produit['categories'][0]['parent_nom_nom'])) {
                    $categorieName .= $produit['categories'][0]['parent_nom_nom'] . ',';
                }

                if (!empty($produit['categories'][0]['categorie_nom_nom'])) {
                    $categorieName .= $produit['categories'][0]['categorie_nom_nom'];
                }
            }

            $out.= "ga('ecommerce:addItem', {\n";
            $out.= "'id': '".$param['extra']['commande_id']."',\n"; // Transaction ID. obligatoire
            $out.= "'name': '".$produit['produit_nom']."',\n"; // Nom produit. obligatoire
            $out.= "'sku': '".$produit['produit_ref']."',\n"; // Numero commande.
            $out.= "'category': '".$categorieName."',\n"; // Categorie produit.
            $out.= "'price': '".$produit['prix_ttc']."',\n"; // Prix unitaire.
            $out.= "'quantity': '".$produit['qte']."'\n"; // Quantite.
            $out.= "});\n";
        }

        $out.= "ga('ecommerce:send');\n";
        $out.= "</script>\n";

        if (isset($param['smarty'])) {
            $param['smarty']->reassign(self::$config['position_paiement'], $out);
        }*/
    }
}
